<?
/*--------------------------------------------+
| PHP-Fusion 5 - Content Management System    |
|---------------------------------------------|
| Photo Gallery v3 - Alpha Release 1          |
|---------------------------------------------|
| Released under the terms and conditions of  |
| the GNU General Public License (Version 2)  |
+---------------------------------------------+
| Photo Gallery coded by CrappoMan            |
|                    (a.k.a. Simon Patterson) |
| email: crappoman@email.com                  |
+--------------------------------------------*/
@require_once "../fusion_config.php";
require_once "../fusion_core.php";
require_once FUSION_BASE."subheader.php";

include FUSION_ADMIN."navigation.php";
include FUSION_INCLUDES."pg_core.php";

if (!checkrights("T")) { header("Location:../index.php");  exit; }

function fatal_error($error){  // display error dialog
  global $PHP_SELF;
  opentable('Fatal Error');
  echo "<center><br />".$error."<br /><br />\n";
  echo "<a href='".$PHP_SELF."'>"."Return to Photo Album Admin"."</a><br /><br />\n";
  echo "<a href='index.php'>"."Return to Admin Index"."</a><br /><br /></center>\n";
  closetable();
  exit();
}

$allowed_params=array(
// action                 t                   required params
 'edit'        => array( 'cat'        => array('album_id'),
                         'album'      => array('album_id') ),
 'delete'      => array( 'cat'        => array('album_id'),
                         'album'      => array('album_id'),
                         'albumimage' => array('album_id') ),
 'moveu'       => array( 'album'      => array('album_id') ),
 'moved'       => array( 'album'      => array('album_id') ),
 'repairorder' => array( 'cat'        => array('album_id'))
);

$param_types=array(
 'album_id' => 'int',
 'order'    => 'int'
);

if(isset($action)) {
  $action=stripinput($action);
  if(array_key_exists($action,$allowed_params)) {
    $t=stripinput($t);
    if(array_key_exists($t,$allowed_params[$action])) {
      $param=$allowed_params[$action][$t];
      foreach($param as $_i=>$_p){
        if(isset($$_p)) {
          $$_p=stripinput($$_p);
        } else {
          fatal_error(sprintf('No %s specified', strtoupper($_p)));
        }
      }
    } else fatal_error('Invalid T specified');
  } else fatal_error('Invalid ACTION specified');
}else{
  $action='';
  $_POST['action']='';
}

if(!isset($t)) $t='';

foreach($param_types as $_p=>$_t){
  if(isset($$_p)) {
    $$_p=stripinput($$_p);
    switch($_t) {
     case 'int':
      if(!isNum($$_p)) fatal_error(sprintf('Invalid %s specified', strtoupper($_p)));
     break;
     case 'any':
     break;
    }
  }else{
    switch($_t) {
     case 'int':
      $$_p=0;
     break;
     case 'string':
      $$_p='';
     break;
     case 'any':
      $$_p=NULL;
     break;
    }
  }
}

if(isset($chk_mark) && count($chk_mark)>0){
  sort($chk_mark);
  $sql_where_album_id="album_id IN(".implode(',',$chk_mark).")";
}

if(isset($_POST['btn_cancel'])){
  header("Location:".FUSION_SELF);  exit();
}elseif(isset($_POST['btn_delete'])){
  if($t=='album'){
    if($settings['pg_image_storage']=='f') {
      foreach($chk_mark as $chk_mark_id) {
        pg_delete_image_file($chk_mark_id,true);
      }
    }
    dbquery("DELETE FROM {$fusion_prefix}photo_albums WHERE {$sql_where_album_id}");
    pg_repair_order_albums_all();
  }
  header("Location:".FUSION_SELF);  exit;
}elseif(isset($_POST['btn_move'])){
  if($t=='album'){
    $order_new=dbresult(dbquery("SELECT MAX(album_order) FROM {$fusion_prefix}photo_albums WHERE album_cat='{$album_move_cat}'"),0)+1;
    $result=dbquery("UPDATE {$fusion_prefix}photo_albums SET album_cat='{$album_move_cat}',album_order='{$order_new}' WHERE {$sql_where_album_id}");
    pg_repair_order_albums_all();
  }
  header("Location:".FUSION_SELF);  exit;
}elseif(isset($_POST['btn_activate'])){
  if($t=='album'){
    $result=dbquery("UPDATE {$fusion_prefix}photo_albums SET album_active='1' WHERE {$sql_where_album_id}");
  }
  header("Location:".FUSION_SELF);  exit;
}elseif(isset($_POST['btn_deactivate'])){
  if($t=='album'){
    $result=dbquery("UPDATE {$fusion_prefix}photo_albums SET album_active='0' WHERE {$sql_where_album_id}");
  }
  header("Location:".FUSION_SELF);  exit;
}elseif($action=='delete'){
  if($t=='cat'){  // delete category
    if(pg_album_exists($album_id,true) && (pg_get_count_albums($album_id)==0)){
      $result=dbquery("DELETE FROM {$fusion_prefix}photo_albums WHERE album_id='{$album_id}'");
      header("Location:".FUSION_SELF);  exit();
    }else{
      fatal_error('Invalid ID specified');
    }
//   }elseif($t=='album'){  // delete album
//     if(pg_album_exists($album_id) && (pg_get_count_images($album_id)==0)){
//       if($settings['pg_image_storage']=='f') { pg_delete_image_file($album_id,true); }
//       $data=dbarray(dbquery("SELECT album_cat,album_order FROM {$fusion_prefix}photo_albums WHERE album_id='{$album_id}' LIMIT 1"));
//       $result=dbquery("UPDATE {$fusion_prefix}photo_albums SET album_order=(album_order-1) WHERE album_cat='{$data['album_cat']}' AND album_order>'{$data['album_order']}'");
//       $result=dbquery("DELETE FROM {$fusion_prefix}photo_albums WHERE album_id='{$album_id}'");
//       header("Location:".FUSION_SELF);  exit();
//     }else{
//       fatal_error('Invalid ID specified');
//     }
  }elseif($t=='albumimage'){  // remove album image
    if(pg_album_exists($album_id)) {
      if($settings['pg_image_storage']=='f') { pg_delete_image_file($album_id,true); }
      $result=dbquery("UPDATE {$fusion_prefix}photo_albums SET album_info='', album_data='' WHERE album_id='{$album_id}'");
      header("Location:".FUSION_SELF."?action=edit&t=album&album_id={$album_id}");  exit();
    }else{
      fatal_error('Invalid ID specified');
    }
  }
}elseif($action=='moveu'){
  if($t=='album'){
    $q_album=dbquery("SELECT album_cat,album_order FROM {$fusion_prefix}photo_albums WHERE album_id='{$album_id}' LIMIT 1");
    if(dbrows($q_album)==1){
      $d_album=dbarray($q_album);
      $ord2=$d_album['album_order']-1;
      $q_id=dbquery("SELECT album_id FROM {$fusion_prefix}photo_albums WHERE album_cat='{$d_album['album_cat']}' AND album_order='{$ord2}' LIMIT 1");
      if(dbrows($q_id)==1){
        $d_id=dbarray($q_id);
        dbquery("UPDATE {$fusion_prefix}photo_albums SET album_order=album_order+1 WHERE album_id='{$d_id['album_id']}'");
        dbquery("UPDATE {$fusion_prefix}photo_albums SET album_order=album_order-1 WHERE album_id='{$album_id}'");
      }
    }
  }
  header("Location:".FUSION_SELF);  exit();
}elseif($action=='moved'){
  if($t=='album'){
    $q_album=dbquery("SELECT album_cat,album_order FROM {$fusion_prefix}photo_albums WHERE album_id='{$album_id}' LIMIT 1");
    if(dbrows($q_album)==1){
      $d_album=dbarray($q_album);
      $ord2=$d_album['album_order']+1;
      $q_id=dbquery("SELECT album_id FROM {$fusion_prefix}photo_albums WHERE album_cat='{$d_album['album_cat']}' AND album_order='{$ord2}' LIMIT 1");
      if(dbrows($q_id)==1){
        $d_id=dbarray($q_id);
        dbquery("UPDATE {$fusion_prefix}photo_albums SET album_order=album_order-1 WHERE album_id='{$d_id['album_id']}'");
        dbquery("UPDATE {$fusion_prefix}photo_albums SET album_order=album_order+1 WHERE album_id='{$album_id}'");
      }
    }
  }
  header("Location:".FUSION_SELF);  exit();
}elseif($action=='repairorder'){
  if($t=='cat'){
    pg_repair_order_albums($album_id);
  }
  header("Location:".FUSION_SELF);  exit();
}else{
  $cat_cnt=pg_get_count_albums(0);
  if($cat_cnt==0) $t='cat';  // hide "Album" form if no categories defined.
  if(isset($_POST['btn_save_cat'])){
    $album_id=stripinput($_POST['album_id']);
    $cat_title=stripinput($_POST['cat_title']);
    $cat_access=(isset($_POST['cat_accesslist'])?'.'.get_optionlist_as_string('cat_accesslist','.').'.':'');
    if(dbresult(dbquery("SELECT COUNT(album_id) FROM {$fusion_prefix}photo_albums WHERE album_cat='0' AND album_id<>'{$album_id}' AND album_title='{$cat_title}'"),0)!=0){
      $error='Error: Category Title already in use';
    }else{
      if($_POST['action']=='edit'){
        $result=dbquery("UPDATE {$fusion_prefix}photo_albums SET album_title='{$cat_title}',album_data='{$cat_access}' WHERE album_id='{$album_id}'");
        $c_id=$album_id;
      }else{
        $result=dbquery("INSERT INTO {$fusion_prefix}photo_albums VALUES ('','0','0','{$cat_title}','','','0','','{$cat_access}')");
        $c_id=dbinsertid();
      }
      if(empty($cat_title) && ($c_id>0)){
        $result=dbquery("UPDATE {$fusion_prefix}photo_albums SET album_title='".sprintf("Category %d",$c_id)."' WHERE album_id='{$c_id}'");
      }
      header("Location:".FUSION_SELF);  exit();
    }
  }elseif(isset($_POST['btn_save_album'])){
    $album_id=stripinput($_POST['album_id']);
    $album_title=stripinput($_POST['album_title']);
    $album_cat=stripinput($_POST['album_cat']);
    $album_password=stripinput($_POST['album_password']);
    $album_active=stripinput($_POST['album_active']);
    $album_desc=stripinput($_POST['album_desc']);
    $album_cat_id=stripinput($_POST['album_cat_id']);
    $album_order=stripinput($_POST['album_order']);
    $upload_info='';
    $upload_data='';
    $upload_data_b64='';
    if(isset($_POST['album_pic_url']) && !empty($_POST['album_pic_url'])){
      $upload_tmp_name=stripinput($_POST['album_pic_url']);
      $upload_size=pg_get_remote_file_size($upload_tmp_name);
      $upload_error=($upload_size==0);
    }elseif(isset($_FILES['album_pic_file']) && is_uploaded_file($_FILES['album_pic_file']['tmp_name'])){
      extract($_FILES['album_pic_file'], EXTR_PREFIX_ALL, 'upload');
    }else{
      $upload_tmp_name='';
    }
    if($upload_tmp_name!=''){
      if($upload_size>=$settings['pg_image_max_b']){
        $error=sprintf('Error: Image file must be less than %u bytes', $settings['pg_image_max_b']);
      }elseif(!$img_info=@getimagesize($upload_tmp_name)){
        $error='Error: Invalid Image File';
      }elseif(($img_info[0]>$settings['pg_image_max_w']) || ($img_info[1]>$settings['pg_image_max_h'])){
        $error=sprintf('Error: Image must be less than %uw x %uh pixels',$settings['pg_image_max_w'],$settings['pg_image_max_h']);
      }elseif(($upload_error==UPLOAD_ERR_INI_SIZE) || ($upload_error==UPLOAD_ERR_FORM_SIZE) ){
        $error='Error: File too big';
      }elseif(!pg_is_allowed_image_type($img_info[2])){
        $error=sprintf('Error: Invalid Image Type.<br />Only <b>%s</b> types allowed',implode(', ',pg_get_allowed_image_types()));
      }else{
        $upload_info = implode('|',array($img_info[2],$img_info[0],$img_info[1]));
        $upload_data = file_get_contents($upload_tmp_name);
        if($settings['pg_image_storage']=='d') { $upload_data_b64=chunk_split(base64_encode($upload_data)); }
      }
    }
    if(($album_password!='') && (!preg_match('/^[0-9a-zA-Z]+$/',$album_password))){
      $error='Error: Password must be alphanumeric';
    }elseif(empty($error)){
      if(empty($album_title)){
        $c_id=dbresult(dbquery("SELECT COUNT(album_id) FROM {$fusion_prefix}photo_albums WHERE album_cat!='0'"),0)+1;
        $album_title="Album {$c_id}";
      }
      if($_POST['action']=='edit'){  // edit current Album
        if($album_cat<>$album_cat_id){  // handle change of Album category
          $order_new=dbresult(dbquery("SELECT MAX(album_order) FROM {$fusion_prefix}photo_albums WHERE album_cat='{$album_cat}'"),0)+1;
          $result=dbquery("UPDATE {$fusion_prefix}photo_albums SET album_cat='{$album_cat}',album_order='{$order_new}' WHERE album_id='{$album_id}'");
          $result=dbquery("UPDATE {$fusion_prefix}photo_albums SET album_order=album_order-1 WHERE album_cat='{$album_cat_id}' AND album_order>'{$album_order}'");
        }
        $result=dbquery("UPDATE {$fusion_prefix}photo_albums SET album_active='{$album_active}',album_title='{$album_title}',album_desc='{$album_desc}',album_password='{$album_password}' WHERE album_id='{$album_id}'");
        if(!empty($upload_info)){
          $result=dbquery("UPDATE {$fusion_prefix}photo_albums SET album_info='{$upload_info}',album_data='{$upload_data_b64}' WHERE album_id='{$album_id}'");
        }
      }else{ // add new Album
        $album_order=dbresult(dbquery("SELECT MAX(album_order) FROM {$fusion_prefix}photo_albums WHERE album_cat='{$album_cat}'"),0)+1;
        $result=dbquery("INSERT INTO {$fusion_prefix}photo_albums VALUES ('','{$album_cat}','{$album_active}','{$album_title}','{$album_desc}','{$album_password}','{$album_order}','{$upload_info}','{$upload_data_b64}')");
        $album_id=mysql_insert_id();
      }
      if(($upload_tmp_name!='') && ($settings['pg_image_storage']=='f')){
        $img_file_name = FUSION_PHOTOS."a{$album_id}.{$image_types_map[$img_info[2]]}";
        $img_file = fopen($img_file_name,'w');
        fwrite($img_file, $upload_data);
        fclose($img_file);
        chmod($img_file_name,0644);
      }
      header("Location:".FUSION_SELF);  exit();
    }
  }elseif($action=='edit') {
    $data=dbarray(dbquery("SELECT * FROM {$fusion_prefix}photo_albums WHERE album_id='{$album_id}'"));
    if($t=='cat') {
      $cat_title=$data['album_title'];
      $album_access_groups=$data['album_data'];
    }elseif($t=='album') {
      $album_cat=$data['album_cat'];
      $album_active=$data['album_active'];
      $album_title=$data['album_title'];
      $album_desc=$data['album_desc'];
      $album_password=$data['album_password'];
      $album_order=$data['album_order'];
      preg_match('/^([0-9]+)\|([0-9]+)\|([0-9]+)$/',$data['album_info'],$album_info_matches);
      $album_has_image=(count($album_info_matches)==4);
    }
  }elseif($action==''){
    $cat_title='';
    $album_cat='';
    $album_active=0;
    $album_title="";
    $album_password='';
    $album_desc='';
    $album_order=0;
    $album_has_image=false;
    $album_access_groups='';
  }
  if ($t != "album") {
    $cat_groups = explode(".", $album_access_groups);
    $user_groups = getusergroups();
    $list1=array();
    $list2=array();
    foreach($user_groups as $key=>$user_group){
      if(in_array($user_group['0'], $cat_groups)) {
        $list2[$user_group['0']] = $user_group['1'];
      } else {
        $list1[$user_group['0']] = $user_group['1'];
      }
    }
    opentable($action=='edit'?'Edit Category':'Add Category');
    echo "<form name='frm_pg_cat' method='post' action='{$PHP_SELF}' onSubmit='select_all_items(\"cat_accesslist2\");'>\n";
    echo "<input type='hidden' name='t' value='cat'>\n";
    echo "<input type='hidden' name='album_id' value='{$album_id}'>\n";
    if(!empty($action)) echo "<input type='hidden' name='action' value='{$action}'>\n";
    echo "<table border='0' cellpadding='0' cellspacing='0' align='center' class='tbl'>\n";
    if(isset($error)) echo "<tr><td class='tbl1 error' align='center' colspan='2'>{$error}</td></tr>";
    echo " <tr>\n";
    echo "  <td class='tbl1' nowrap>"."Title".":</td>\n";
    echo "  <td class='tbl1' nowrap><input type='text' name='cat_title' value='{$cat_title}' class='textbox' style='width:250px;'></td>\n";
    echo " </tr>\n";
    echo " <tr>\n";
    echo "  <td class='tbl1' nowrap valign='top'>"."Group Access".":</td>\n";
    echo "  <td class='tbl1'>\n";
    echo "   <table border='0' cellpadding='0' cellspacing='0' align='center'>\n";
    echo "    <tr>\n";
    echo "     <td><span class='small'><i>"."User Groups"."</i></span><br /><select multiple size='7' name='cat_grouplist[]' id='cat_accesslist1' class='textbox' style='width:120px;' onDblClick='move_items(\"cat_accesslist1\",\"cat_accesslist2\",false)'>\n".pg_build_optionlist_from_array($list1)."</select>\n<br />";
    echo "<div align='center'><input type='button' class='button' onClick='move_items(\"cat_accesslist1\",\"cat_accesslist2\",true)' value='All&nbsp;&raquo;'>&nbsp;<input type='button' class='button' onClick='move_items(\"cat_accesslist1\",\"cat_accesslist2\",false)' value='&nbsp;&raquo;&nbsp;'></div>\n</td>\n";
    echo "     <td><span class='small'><i>"."Selected Groups"."</i></span><br /><select multiple size='7' name='cat_accesslist[]' id='cat_accesslist2' class='textbox' style='width:120px;' onDblClick='move_items(\"cat_accesslist2\",\"cat_accesslist1\",false)'>\n".pg_build_optionlist_from_array($list2)."</select>\n<br />";
    echo "<div align='center'><input type='button' class='button' onClick='move_items(\"cat_accesslist2\",\"cat_accesslist1\",false)' value='&nbsp;&laquo;&nbsp;'>&nbsp;<input type='button' class='button' onClick='move_items(\"cat_accesslist2\",\"cat_accesslist1\",true)' value='&laquo;&nbsp;All'></div>\n</td>\n";
    echo "    </tr>\n";
    echo "   </table>\n";
    echo "  </td>\n";
    echo " </tr>\n";
    echo " <tr>\n";
    echo "  <td class='tbl1' nowrap colspan='2'><hr></td>\n";
    echo " </tr>\n";
    echo " <tr>\n";
    echo "  <td class='tbl1' colspan='2' align='center'><input type='submit' name='btn_save_cat' value='"."Save Category"."' class='button'>".($action=='edit' || isset($error)?"&nbsp;<input type='submit' name='btn_cancel' value='"."Cancel"."' class='button'>":"")."</td>\n";
    echo " </tr>\n";
    echo "</table>\n";
    echo "</form>\n";
    echo "<script type='text/javascript'>select_sort(document.getElementById('cat_accesslist1'));select_sort(document.getElementById('cat_accesslist2'));</script>\n";
    closetable();
  }
  if (!$t) tablebreak();
  if ($t != "cat") {
    opentable($action=='edit'?'Edit Album':'Add Album');
    echo "<form name='frm_pg_album' method='post' action='{$PHP_SELF}' enctype='multipart/form-data'>\n";
    echo "<input type='hidden' name='t' value='album'>\n";
    echo "<input type='hidden' name='album_id' value='{$album_id}'>\n";
    if(!empty($action)) echo "<input type='hidden' name='action' value='{$action}'>\n";
    echo "<input type='hidden' name='album_cat_id' value='{$album_cat}'>\n<input type='hidden' name='album_order' value='{$album_order}'>\n";
    echo "<table border='0' cellpadding='0' cellspacing='0' align='center' class='tbl-border'>\n";
    if(isset($error)) echo "<tr><td class='tbl1 error' align='center' colspan='2'>{$error}</td></tr>";
    echo " <tr>\n";
    echo "  <td class='tbl1' nowrap>"."Album Title".":</td>\n";
    echo "  <td class='tbl1' nowrap><input type='text' name='album_title' value='{$album_title}' class='textbox' style='width:250px;'></td>\n";
    echo " </tr>\n";
    echo " <tr>\n";
    echo "  <td class='tbl1' nowrap>"."Category".":</td>\n";
    echo "  <td class='tbl1' nowrap><select name='album_cat' class='textbox' style='width:250px;'>".pg_build_category_optionlist($album_cat,false)."</select></td>\n";
    echo " </tr>\n";
    echo " <tr>\n";
    echo "  <td class='tbl1' nowrap valign='top'>"."Description".":</td>\n";
    echo "  <td class='tbl1' nowrap><textarea name='album_desc' class='textbox' style='width:250px; height:40px;'>{$album_desc}</textarea></td>\n";
    echo " </tr>\n";
    echo " <tr>\n";
    echo "  <td class='tbl1' nowrap>"."Password".":</td>\n";
    echo "  <td class='tbl1' nowrap><input type='text' name='album_password' value='{$album_password}' class='textbox' style='width:250px;'></td>\n";
    echo " </tr>\n";
    echo " <tr>\n";
    echo "  <td class='tbl1' nowrap>"."Active".":</td>\n";
    echo "  <td class='tbl1' nowrap><select name='album_active' class='textbox' style='width:250px;'>".pg_build_optionlist_from_array($bool_states,$album_active)."</select></td>\n";
    echo " </tr>\n";
    echo " <tr>\n";
    echo "  <td class='tbl1' nowrap colspan='2'><hr></td>\n";
    echo " </tr>\n";
    if($album_has_image && $action=='edit'){
      $album_info=sprintf('%dx%d pixels (%s)',$album_info_matches[2],$album_info_matches[3],$image_types_map[$album_info_matches[1]]);
      echo " <tr>\n";
      echo "  <td class='tbl1' nowrap colspan='2'>"."Current Image".":&nbsp;&nbsp;[<a class='small' href='{$PHP_SELF}?action=delete&t=albumimage&album_id={$album_id}' title='"."Remove the current Image"."'>"."Remove"."</a>]</td>\n";
      echo " </tr>\n";
      echo " <tr>\n";
      echo "  <td class='tbl1' nowrap colspan='2' align='center'><a class='gallery-album' target='_blank' href='".FUSION_BASE."getpgimage.php?t=album&id={$album_id}' title='"."Click to view this image"."'><img src='".FUSION_BASE."getpgimage.php?t=album&id={$album_id}&w={$settings['pg_thumb_max_w']}&h={$settings['pg_thumb_max_h']}' border='0'></a><br /><span class='small'>{$album_info}</span></td>\n";
      echo " </tr>\n";
    }else{
      echo " <tr>\n";
      echo "  <td class='tbl1' nowrap valign='top'>"."Upload Image".":</td>\n";
      echo "  <td class='tbl1' nowrap><input type='file' name='album_pic_file' class='textbox' size='33' style='width:250px;'></td>\n";
      echo " </tr>\n";
      echo " <tr>\n";
      echo "  <td class='tbl1' nowrap valign='top'>"."Get From URL".":</td>\n";
      echo "  <td class='tbl1' nowrap><input type='text' name='album_pic_url' value='' class='textbox' style='width:250px;'></td>\n";
      echo " </tr>\n";
      echo " <tr>\n";
      echo "  <td class='tbl1' nowrap valign='top'>"."Allowed Types".":</td>\n";
      echo "  <td class='tbl1'><span class='small'>".implode(', ',pg_get_allowed_image_types())."</span></td>\n";
      echo " </tr>\n";
    }
    echo " <tr>\n";
    echo "  <td class='tbl1' nowrap colspan='2'><hr></td>\n";
    echo " </tr>\n";
    echo " <tr>\n";
    echo "  <td class='tbl1' nowrap colspan='2' align='center'><input type='submit' name='btn_save_album' value='"."Save Album"."' class='button'>".($action=='edit' || isset($error)?"&nbsp;<input type='submit' name='btn_cancel' value='"."Cancel"."' class='button'>":"")."</td>\n";
    echo " </tr>\n";
    echo "</table>\n";
    echo "</form>\n";
    closetable();
  }
  if($action==''){
    tablebreak();
    opentable("Current Albums");
    echo "<form name='frm_pg_album_list' method='post' action='{$PHP_SELF}' onSubmit=\"return ValidateForm(this,'chk_mark[]')\">\n";
    echo "<input type='hidden' name='t' value='album'>\n";
    echo "<table border='0' cellpadding='0' cellspacing='1' width='100%' class='tbl-border'>\n";
    echo " <tr>\n";
    echo "  <td class='forum-caption' width='*' colspan='3'>"."Title - (Click to edit)"."</td>\n";
    echo "  <td class='forum-caption' nowrap width='5%' align='center'>"."Password"."</td>\n";
    echo "  <td class='forum-caption' nowrap width='5%' align='center'>"."Image"."</td>\n";
    echo "  <td class='forum-caption' nowrap width='5%' align='center'>"."Contents"."</td>\n";
    echo "  <td class='forum-caption' nowrap width='5%' align='center' colspan='2'>"."Order"."</td>\n";
    echo "  <td class='forum-caption' nowrap width='5%' align='right'>"."Options"."</td>\n";
    echo " </tr>\n";
    $q_cats=dbquery(
      "SELECT tc.album_id,tc.album_title,tc.album_data,COUNT(ta.album_id) album_count ".
      "FROM {$fusion_prefix}photo_albums tc LEFT JOIN {$fusion_prefix}photo_albums ta ON tc.album_id=ta.album_cat ".
      "WHERE tc.album_cat='0' GROUP BY tc.album_id ORDER BY tc.album_title"
    );
    if(dbrows($q_cats)!=0){
      while($d_cats=dbarray($q_cats)){
        $grps=substr($d_cats['album_data'],1,-1);  // remove surrounding '.' characters
        $cat_groups_1=explode('.',$grps);
        $cat_groups_2=array();
        foreach($cat_groups_1 as $key=>$cat_group) { $cat_groups_2[]=getgroupname($cat_group); }
        $str_cat_groups=implode(', ',array_values($cat_groups_2));
        echo " <tr>\n";
        echo "  <td class='tbl2' colspan='9'>\n";
        echo "   <table border='0' cellpadding='0' cellspacing='0' width='100%'>\n";
        echo "    <tr>\n";
        echo "     <td nowrap><a href='{$PHP_SELF}?action=edit&t=cat&album_id={$d_cats['album_id']}' title='"."Edit this Category"."'><b>{$d_cats['album_title']}</b></a><br /><span class='small'>Accessible to: {$str_cat_groups}</span></td>\n";
        echo "     <td nowrap align='right'><span class='small'>";
        if($d_cats['album_count']!=0){
          echo "<a href='{$PHP_SELF}?action=repairorder&t=cat&album_id={$d_cats['album_id']}' title='"."Repair the order of albums in this category"."'>"."Repair Ordering"."</a>";
        }else{
          echo "<a href='{$PHP_SELF}?action=delete&t=cat&album_id={$d_cats['album_id']}' title='"."Delete this Category"."'>"."Delete"."</a>";
        }
        echo "</td>\n";
        echo "    </tr>\n";
        echo "   </table>\n";
        echo "  </td>\n";
        echo " </tr>\n";
        $q_albums=dbquery(
          "SELECT ta.album_id,ta.album_active,ta.album_title,ta.album_desc,ta.album_password,ta.album_order,ta.album_info, COUNT(tp.photo_id) photo_count ".
          "FROM {$fusion_prefix}photo_albums ta LEFT JOIN {$fusion_prefix}photos tp USING (album_id) ".
          "WHERE album_cat='{$d_cats['album_id']}' GROUP BY album_id ORDER BY album_order"
        );
        $album_cnt=dbrows($q_albums);
        if($album_cnt!=0){
          while($d_albums=dbarray($q_albums)){
            preg_match('/^([0-9]+)\|([0-9]+)\|([0-9]+)$/',$d_albums['album_info'],$album_info_matches);
            if($album_cnt!=1){
              if($d_albums['album_order']==1){
                $up_down="<a href='{$PHP_SELF}?action=moved&t=album&album_id={$d_albums['album_id']}' title='"."Move this Album down"."'><img src='".FUSION_THEME."images/down.gif' border='0' /></a>";
              }elseif($d_albums['album_order']<$album_cnt){
                $up_down="<a href='{$PHP_SELF}?action=moveu&t=album&album_id={$d_albums['album_id']}' title='"."Move this Album up"."'><img src='".FUSION_THEME."images/up.gif' border='0' /></a>";
                $up_down.="&nbsp;<a href='{$PHP_SELF}?action=moved&t=album&album_id={$d_albums['album_id']}' title='"."Move this Album down"."'><img src='".FUSION_THEME."images/down.gif' border='0' /></a>";
              }else{
                $up_down="<a href='{$PHP_SELF}?action=moveu&t=album&album_id={$d_albums['album_id']}' title='"."Move this Album up"."'><img src='".FUSION_THEME."images/up.gif' border='0' /></a>";
              }
            }else{
              $up_down="-";
            }
            echo " <tr>\n";

            echo "  <td class='tbl1' style='padding:0px;' nowrap width='2%' align='center'><input type='checkbox' name='chk_mark[]' value='{$d_albums['album_id']}'></td>\n";
            echo "  <td class='tbl1' nowrap width='2%' align='center'><img src='".FUSION_IMAGES.$album_state_map[$d_albums['album_active']][0]."' border='0' title='".$album_state_map[$d_albums['album_active']][1]."'></td>\n";
            echo "  <td class='tbl1' nowrap><a href='{$PHP_SELF}?action=edit&t=album&album_id={$d_albums['album_id']}' title='"."Edit this Album"."'>{$d_albums['album_title']}</a></td>\n";
            echo "  <td class='tbl1' nowrap align='center'>".($d_albums['album_password']!=''?TICK:'-')."</td>\n";
            echo "  <td class='tbl1' nowrap align='center'>".(count($album_info_matches)==4?$image_types_map[$album_info_matches[1]]:'-')."</td>\n";
            echo "  <td class='tbl1 small' nowrap align='center'>".($d_albums['photo_count']==0?'None':$d_albums['photo_count'])."</td>\n";
            echo "  <td class='tbl1 small' nowrap width='2%' align='center'>{$d_albums['album_order']}</td>\n";
            echo "  <td class='tbl1' nowrap width='3%' align='center'>{$up_down}</td>\n";
            echo "  <td class='tbl1' nowrap align='right'><a href='".FUSION_ADMIN."photos.php?album_id={$d_albums['album_id']}' title='"."Open this Album"."'>"."Open"."</a></td>\n";
            echo " </tr>\n";
          }
        }else{
          echo " <tr>\n";
          echo "  <td class='tbl1' nowrap width='3%' align='center'><img src='".FUSION_IMAGES."cross_red.gif' border='0' alt='"."Loading Image..."."' title='"."No Photo Albums defined"."'>\n";
          echo "  <td class='tbl1' nowrap width='97%' colspan='8'>"."No Photo Albums defined"."</td>\n";
          echo " </tr>\n";
        }
      }
    }else{
      echo " <tr>\n";
      echo "  <td class='tbl1' nowrap width='3%' align='center'><img src='".FUSION_IMAGES."cross_red.gif' border='0' alt='"."Loading Image..."."' title='"."No Photo Album Categories defined"."'>\n";
      echo "  <td class='tbl1' nowrap width='97%' colspan='8'>"."No Photo Album Categories defined"."</td>\n";
      echo " </tr>\n";
    }
    echo "</table>\n";
    if(dbrows($q_cats)!=0){
      echo "<table border='0' cellpadding='0' cellspacing='0' width='100%'>\n";
      echo " <tr>\n";
      echo "  <td><span class='small'><input type='button' class='button' title='"."Click to mark all albums"."' onclick=\"javascript:setChecked('frm_pg_album_list','chk_mark[]',1);\" value='"."Mark All"."'</input>&nbsp;<input type='button' class='button' title='"."Click to unmark all images"."' onclick=\"javascript:setChecked('frm_pg_album_list','chk_mark[]',0);\" value='"."Unmark All"."'</input></span></td>\n";
      echo "  <td align='right'>";
      echo "With marked albums:"."&nbsp;";
      echo "<input type='submit' class='button' name='btn_activate' title='"."Activate"."' value='"."Activate"."'>&nbsp;";
      echo "<input type='submit' class='button' name='btn_deactivate' title='"."Deactivate"."' value='"."Deactivate"."'>&nbsp;";
      echo "<input type='submit' class='button' name='btn_delete' title='"."Delete"."' value='"."Delete"."'>&nbsp;|&nbsp;";
      echo "Move to <select name='album_move_cat' class='textbox' style='width:auto;'>".pg_build_category_optionlist($album_cat,false)."</select>&nbsp;";
      echo "<input type='submit' class='button' name='btn_move' title='"."Go"."' value='"."Move"."'></td>";
      echo " </tr>\n";
      echo "</table>\n";
    }
    echo "</form>\n";
    echo "<script language='Javascript'>
function confirmDelete(name){return confirm('"."Delete "."\''+name+'\'\\n\\nAre you sure ?');}
function ValidateForm(frm){if((frm.subject.value=='')||(frm.message.value=='')){alert('"."Please select at least one record to be actioned"."');return false;}else return true;}
function setChecked(frmName,chkName,val){
  dml=document.forms[frmName];
  len=dml.elements.length;
  for(i=0;i<len;i++){
    if(dml.elements[i].name==chkName){
      dml.elements[i].checked=val;
    }
  }
}
function ValidateForm(dml,chkName){
  len=dml.elements.length;
  for(i=0;i<len;i++){
    if((dml.elements[i].name==chkName)&&(dml.elements[i].checked==1)) return true
  }
  alert('Please select at least one record to be actioned')
  return false;
}
</script>";
//     tablebreak();
//     $storage_type = ($settings['pg_image_storage']=='f'?'file':'database');
//     echo "Image Storage Mode: {$storage_type}";
    closetable();

tablebreak();
pg_show_db_info();

  }
}

echo "</td>\n";
include FUSION_BASE."footer.php";
?>