<?
/*--------------------------------------------+
| PHP-Fusion 5 - Content Management System    |
|---------------------------------------------|
| Photo Gallery v3 - Alpha Release 1          |
|---------------------------------------------|
| Released under the terms and conditions of  |
| the GNU General Public License (Version 2)  |
+---------------------------------------------+
| Photo Gallery coded by CrappoMan            |
|                    (a.k.a. Simon Patterson) |
| email: crappoman@email.com                  |
+--------------------------------------------*/
@require_once "../fusion_config.php";
require_once "../fusion_core.php";
require_once FUSION_BASE."subheader.php";

include FUSION_LANGUAGES.FUSION_LAN."comments.php";
include FUSION_LANGUAGES.FUSION_LAN."ratings.php";
include FUSION_ADMIN."navigation.php";
include FUSION_INCLUDES."pg_core.php";

if (!checkrights("T")) { header("Location:../index.php");  exit; }

function fatal_error($error){  // display error dialog
  global $PHP_SELF;
  opentable("Fatal Error");
  echo "<center><br />".$error."<br /><br />\n";
  echo "<a href='".$PHP_SELF."'>"."Return to Photos Admin"."</a><br /><br />\n";
  echo "<a href='index.php'>"."Return to Admin Index"."</a><br /><br /></center>\n";
  closetable();
  exit();
}

$allowed_params=array(
// action                 t                   required params
 'edit'        => array( 'photo'      => array('album_id', 'photo_id') ),
 'delete'      => array( 'photoimage' => array('album_id', 'photo_id') ),
 'moveu'       => array( 'photo'      => array('album_id', 'photo_id') ),
 'moved'       => array( 'photo'      => array('album_id', 'photo_id') ),
 'repairorder' => array( 'album'      => array('album_id') )
);

$param_types=array(
 'album_id' => 'int',
 'photo_id' => 'int',
 'order'    => 'int',
 'photo_move_album' => 'int'
);

if(!isset($album_id)){
  $q_default_album_info=dbquery(
    "SELECT ta.album_id ".
    "FROM {$fusion_prefix}photo_albums tc ".
    "LEFT JOIN {$fusion_prefix}photo_albums ta ON tc.album_id=ta.album_cat ".
    "WHERE tc.album_cat='0' ".
    "GROUP BY tc.album_id, ta.album_id ".
    "ORDER BY tc.album_title, ta.album_order ".
    "LIMIT 1"
  );
  if(dbrows($q_default_album_info)==1){
    $album_id=dbresult($q_default_album_info,0);
  }else{
    header('Location: photoalbums.php');  exit;
  }
}

if(!isset($page)) $page=1;

if(isset($action)) {
  $action=stripinput($action);
  if(array_key_exists($action,$allowed_params)) {
    $t=stripinput($t);
    if(array_key_exists($t,$allowed_params[$action])) {
      $param=$allowed_params[$action][$t];
      foreach($param as $_i=>$_p){
        if(isset($$_p)) {
          $$_p=stripinput($$_p);
        } else {
          fatal_error(sprintf('No %s specified', strtoupper($_p)));
        }
      }
    } else fatal_error('Invalid T specified');
  } else fatal_error('Invalid ACTION specified');
}else{
  $action='';
  $_POST['action']='';
}

if(!isset($t)) $t='';

foreach($param_types as $_p=>$_t){
  if(isset($$_p)) {
    $$_p=stripinput($$_p);
    switch($_t) {
     case 'int':
      if(!isNum($$_p)) fatal_error(sprintf('Invalid %s specified', strtoupper($_p)));
     break;
     case 'any':
     break;
    }
  }else{
    switch($_t) {
     case 'int':
      $$_p=0;
     break;
     case 'string':
      $$_p='';
     break;
     case 'any':
      $$_p=NULL;
     break;
    }
  }
}

$q_album_info=dbquery(
  "SELECT ta.album_id, tc.album_title AS cat_title, tc.album_data AS cat_data, ta.album_title, COUNT(photo_id) photo_count ".
  "FROM {$fusion_prefix}photo_albums tc ".
  "JOIN {$fusion_prefix}photo_albums ta ON ta.album_cat=tc.album_id ".
  "LEFT JOIN {$fusion_prefix}photos tp ON ta.album_id=tp.album_id ".
  "WHERE ta.album_id='{$album_id}' ".
  "GROUP BY ta.album_id"
);
$d_album_info=dbarray($q_album_info);

if(isset($chk_mark) && count($chk_mark)>0){
  sort($chk_mark);
  $sql_where_photo_id="photo_id IN(".implode(',',$chk_mark).")";
}

if(dbrows($q_album_info)!=1){
  fatal_error('Invalid ALBUM_ID specified');
}elseif(isset($_POST['btn_cancel'])){
  header("Location:".FUSION_SELF."?album_id={$album_id}");  exit;
}elseif(isset($_POST['btn_delete'])){
  if($t=='photo'){
    if($settings['pg_image_storage']=='f') {
      foreach($chk_mark as $chk_mark_id) {
        pg_delete_image_file($chk_mark_id,false);
      }
    }
    dbquery("DELETE FROM {$fusion_prefix}photos WHERE {$sql_where_photo_id}");
    pg_repair_order_photos($album_id);
  }
  header("Location:".FUSION_SELF."?album_id={$album_id}");  exit;
}elseif(isset($_POST['btn_move'])){
  if($t=='photo'){
    $order_new=dbresult(dbquery("SELECT MAX(photo_order) FROM {$fusion_prefix}photos WHERE album_id='{$photo_move_album}'"),0)+1;
    $result=dbquery("UPDATE {$fusion_prefix}photos SET album_id='{$photo_move_album}',photo_order='{$order_new}' WHERE {$sql_where_photo_id}");
    pg_repair_order_photos($album_id);
    pg_repair_order_photos($photo_move_album);
  }
  header("Location:".FUSION_SELF."?album_id={$album_id}");  exit;
}elseif(isset($_POST['btn_activate'])){
  if($t=='photo'){
    $result=dbquery("UPDATE {$fusion_prefix}photos SET photo_active='1' WHERE {$sql_where_photo_id}");
  }
  header("Location:".FUSION_SELF."?album_id={$album_id}");  exit;
}elseif(isset($_POST['btn_deactivate'])){
  if($t=='photo'){
    $result=dbquery("UPDATE {$fusion_prefix}photos SET photo_active='0' WHERE {$sql_where_photo_id}");
  }
  header("Location:".FUSION_SELF."?album_id={$album_id}");  exit;
}elseif($action=='delete'){
  if($t=='photoimage'){  // remove album thumbnail
    if(!pg_album_exists($album_id)) {
      fatal_error('Invalid ALBUM_ID specified');
    }elseif(!pg_photo_exists($photo_id)) {
      fatal_error('Invalid PHOTO_ID specified');
    }else{
      if($settings['pg_image_storage']=='f') { pg_delete_image_file($photo_id,false); }
      $result=dbquery("UPDATE {$fusion_prefix}photos SET photo_info='', photo_data='' WHERE photo_id='{$photo_id}'");
      header("Location:".FUSION_SELF."?action=edit&t=photo&album_id={$album_id}&photo_id={$photo_id}");  exit;
    }
  }
}elseif($action=='moveu'){
  if($t=='photo'){
    $q_photo=dbquery("SELECT photo_order FROM {$fusion_prefix}photos WHERE photo_id='{$photo_id}'");
    if(dbrows($q_photo)==1){
      $d_photo=dbarray($q_photo);
      $ord2=($d_photo['photo_order']-1);
      $q_id=dbquery("SELECT photo_id FROM {$fusion_prefix}photos WHERE album_id='{$album_id}' AND photo_order='{$ord2}'");
      if(dbrows($q_id)==1){
        $d_id=dbarray($q_id);
        dbquery("UPDATE {$fusion_prefix}photos SET photo_order=photo_order+1 WHERE photo_id='{$d_id['photo_id']}'");
        dbquery("UPDATE {$fusion_prefix}photos SET photo_order=photo_order-1 WHERE photo_id='{$photo_id}'");
      }
    }
  }
  header("Location:".FUSION_SELF."?album_id={$album_id}");  exit;
}elseif($action=='moved'){
  if($t=='photo'){
    $q_photo=dbquery("SELECT photo_order FROM {$fusion_prefix}photos WHERE photo_id='{$photo_id}'");
    if(dbrows($q_photo)==1){
      $d_photo=dbarray($q_photo);
      $ord2=($d_photo['photo_order']+1);
      $q_id=dbquery("SELECT photo_id FROM {$fusion_prefix}photos WHERE album_id='{$album_id}' AND photo_order='{$ord2}'");
      if(dbrows($q_id)==1){
        $d_id=dbarray($q_id);
        dbquery("UPDATE {$fusion_prefix}photos SET photo_order=photo_order-1 WHERE photo_id='{$d_id['photo_id']}'");
        dbquery("UPDATE {$fusion_prefix}photos SET photo_order=photo_order+1 WHERE photo_id='{$photo_id}'");
      }
    }
  }
  header("Location:".FUSION_SELF."?album_id={$album_id}");  exit;
}elseif($action=='repairorder'){
  if($t=='album'){
    pg_repair_order_photos($album_id);
  }
  header("Location:".FUSION_SELF."?album_id={$album_id}");  exit;
}else{
  if(isset($_POST['btn_save_photo'])){
    $album_id=stripinput($_POST['album_id']);
    $photo_album=stripinput($_POST['photo_album']);
    $photo_id=stripinput($_POST['photo_id']);
    $photo_order=stripinput($_POST['photo_order']);
    $photo_title=stripinput($_POST['photo_title']);
    $photo_desc=stripinput($_POST['photo_desc']);
    $photo_active=stripinput($_POST['photo_active']);
    $photo_added_by=stripinput($_POST['photo_added_by']);
    $photo_date_d=stripinput($_POST['photo_date_d']);
    $photo_date_m=stripinput($_POST['photo_date_m']);
    $photo_date_y=stripinput($_POST['photo_date_y']);
    list($photo_date_hour,$photo_date_min,$photo_date_sec)=explode(':',stripinput($_POST['photo_date_t']));
    $photo_date=mktime($photo_date_hour,$photo_date_min,$photo_date_sec,$photo_date_m,$photo_date_d,$photo_date_y);
    $upload_info='';
    $upload_data='';
    $upload_data_b64='';
    if(isset($_POST['photo_pic_url']) && !empty($_POST['photo_pic_url'])){
      $upload_tmp_name=stripinput($_POST['photo_pic_url']);
      $upload_size=pg_get_remote_file_size($upload_tmp_name);
      $upload_error=($upload_size==0);
    }elseif(isset($_FILES['photo_pic_file']) && is_uploaded_file($_FILES['photo_pic_file']['tmp_name'])){
      extract($_FILES['photo_pic_file'], EXTR_PREFIX_ALL, 'upload');
    }else{
      $upload_tmp_name='';
    }
    if($upload_tmp_name!=''){
      if($upload_size>=$settings['pg_image_max_b']){
        $error=sprintf('Error: Image file must be less than %u bytes', $settings['pg_image_max_b']);
      }elseif(!$img_info=@getimagesize($upload_tmp_name)){
        $error='Error: Invalid Image File';
      }elseif(($img_info[0]>$settings['pg_image_max_w']) || ($img_info[1]>$settings['pg_image_max_h'])){
        $error=sprintf('Error: Image must be less than %uw x %uh pixels',$settings['pg_image_max_w'],$settings['pg_image_max_h']);
      }elseif(($upload_error==UPLOAD_ERR_INI_SIZE) || ($upload_error==UPLOAD_ERR_FORM_SIZE) ){
        $error='Error: File too big';
      }elseif(!pg_is_allowed_image_type($img_info[2])){
        $error=sprintf('Error: Invalid Image Type.<br />Only <b>%s</b> types allowed',implode(', ',pg_get_allowed_image_types()));
      }else{
        $upload_info = implode('|',array($img_info[2],$img_info[0],$img_info[1]));
        $upload_data = file_get_contents($upload_tmp_name);
        if($settings['pg_image_storage']=='d') { $upload_data_b64=chunk_split(base64_encode($upload_data)); }
      }
    }
    if(empty($error)){
      if(empty($photo_title)){
        $c_id=dbresult(dbquery("SELECT COUNT(photo_id) FROM {$fusion_prefix}photos WHERE album_id='{$album_id}'"),0)+1;
        $photo_title="Image {$c_id}";
      }
      if($_POST['action']=='edit'){  // edit current photo
        if($photo_album<>$album_id){  // handle change of photo album
          $order_new=dbresult(dbquery("SELECT MAX(photo_order) FROM {$fusion_prefix}photos WHERE album_id='{$photo_album}'"),0)+1;
          $result=dbquery("UPDATE {$fusion_prefix}photos SET album_id='{$photo_album}',photo_order='{$order_new}' WHERE photo_id='{$photo_id}'");
          $result=dbquery("UPDATE {$fusion_prefix}photos SET photo_order=photo_order-1 WHERE album_id='{$album_id}' AND photo_order>'{$photo_order}'");
        }
        $result=dbquery("UPDATE {$fusion_prefix}photos SET photo_active='{$photo_active}',photo_title='{$photo_title}',photo_desc='{$photo_desc}',photo_date='{$photo_date}',user_id='{$photo_added_by}' WHERE photo_id='{$photo_id}'");
        if(!empty($upload_info)){
          $result=dbquery("UPDATE {$fusion_prefix}photos SET photo_info='{$upload_info}',photo_data='{$upload_data_b64}' WHERE photo_id='{$photo_id}'");
        }
      }else{ // add new photo
        $order_new=dbresult(dbquery("SELECT MAX(photo_order) FROM {$fusion_prefix}photos WHERE album_id='{$photo_album}'"),0)+1;
        $result=dbquery("INSERT INTO {$fusion_prefix}photos VALUES ('','{$photo_album}','{$photo_active}','{$photo_title}','{$photo_desc}','{$order_new}','{$photo_date}','{$photo_added_by}','0','{$upload_info}','{$upload_data}')");
        $photo_id=mysql_insert_id();
      }
      if(($upload_tmp_name!='') && ($settings['pg_image_storage']=='f')){
        $img_file_name = FUSION_PHOTOS."{$photo_id}.{$image_types_map[$img_info[2]]}";
        $img_file = fopen($img_file_name,'w');
        fwrite($img_file, $upload_data);
        fclose($img_file);
        chmod($img_file_name,0644);
      }
      header("Location:".FUSION_SELF."?album_id={$album_id}");  exit;
    }
  }elseif($action=='edit'){
    $result=dbquery(
      "SELECT tp.photo_id, tp.album_id, tp.photo_active, tp.photo_title, tp.photo_desc, tp.photo_order, tp.photo_date, tp.user_id, tp.photo_views, tp.photo_info, user_name, COUNT(comment_id) AS comment_count ".
      "FROM ({$fusion_prefix}photos tp INNER JOIN {$fusion_prefix}users USING (user_id)) ".
      "LEFT JOIN {$fusion_prefix}comments ON photo_id = comment_item_id AND comment_type = 'P' ".
      "WHERE photo_id='{$photo_id}' ".
      "GROUP BY photo_id "
    );
    $data=dbarray($result);
    $photo_id=$data['photo_id'];
    $album_id=$data['album_id'];
    $photo_order=$data['photo_order'];
    $photo_title=$data['photo_title'];
    $photo_desc=$data['photo_desc'];
    $photo_active=$data['photo_active'];
    $photo_added_by=$data['user_id'];
    list($photo_date_d,$photo_date_m,$photo_date_y)=explode('-',date('d-m-Y',$data['photo_date']+($settings['timeoffset']*3600)));
    $photo_date_t=date('H:i:s',$data['photo_date']+($settings['timeoffset']*3600));
    $photo_comments=$data['comment_count'];
    preg_match('/^([0-9]+)\|([0-9]+)\|([0-9]+)$/',$data['photo_info'],$photo_info_matches);
    $photo_has_image=(count($photo_info_matches)==4);
  }elseif($action==''){
    $photo_title='';
    $photo_desc='';
    $photo_active=0;
    $photo_added_by=0;
    $photo_date_d=date('d');
    $photo_date_m=date('m');
    $photo_date_y=date('Y');
    $photo_date_t=date('H:i:s');
    $photo_comments=0;
    $photo_order=0;
    $photo_has_image=false;
  }
  opentable($action=='edit'?'Edit Photo':'Add Photo');
  // populate Day & Month drop down box
  $months=explode("|",LAN_MONTHS);
  $month_list="";
  for($i=1; $i<count($months); $i++) $month_list.="<option value='".$i."'".($i==$photo_date_m?" selected":"").">".$months[$i]."</option>\n";
  $day_list="";
  for($i=1; $i<32; $i++) $day_list.="<option value='".$i."'".($i==$photo_date_d?" selected":"").">".$i."</option>\n";
  echo "<form name='frm_pg_image' method='post' action='{$PHP_SELF}' enctype='multipart/form-data'>\n";
  if(!empty($action)) echo "<input type='hidden' name='action' value='{$action}'>\n";
  echo "<input type='hidden' name='t' value='photo'>\n";
  echo "<input type='hidden' name='photo_id' value='{$photo_id}'>\n";
  echo "<input type='hidden' name='album_id' value='{$album_id}'>\n";
  echo "<input type='hidden' name='photo_order' value='{$photo_order}'>\n";
  echo "<table border='0' cellpadding='0' cellspacing='0' align='center' class='tbl'>\n";
  if(isset($error)) echo "<tr><td class='tbl1 required' align='center' colspan='2'>{$error}</td></tr>";
  echo " <tr>\n";
  echo "  <td class='tbl1' nowrap>"."Title".":</td>\n";
  echo "  <td class='tbl1' nowrap><input type='text' name='photo_title' value='{$photo_title}' maxlength='100' class='textbox' style='width:250px;'></td>\n";
  echo " </tr>\n";
  echo " <tr>\n";
  echo "  <td class='tbl1' nowrap>"."Album".":</td>\n";
  echo "  <td class='tbl1' nowrap><select name='photo_album' class='textbox' style='width:250px;'>".pg_build_album_optionlist(false,0,$album_id)."</select></td>\n";
  echo " </tr>\n";
  echo " <tr>\n";
  echo "  <td class='tbl1' nowrap valign='top'>"."Description".":</td>\n";
  echo "  <td class='tbl1' nowrap><textarea name='photo_desc' class='textbox' style='width:250px; height:40px;'>{$photo_desc}</textarea></td>\n";
  echo " </tr>\n";
  echo " <tr>\n";
  echo "  <td class='tbl1' nowrap>"."Active".":</td>\n";
  echo "  <td class='tbl1' nowrap><select name='photo_active' class='textbox' style='width:250px;'>".pg_build_optionlist_from_array($bool_states,$photo_active)."</select></td>\n";
  echo " </tr>\n";
  echo " <tr>\n";
  echo "  <td class='tbl1' nowrap>"."Added By".":</td>\n";
  echo "  <td class='tbl1' nowrap><select name='photo_added_by' class='textbox' style='width:250px;'>".pg_build_user_optionlist($photo_added_by)."</select></td>\n";
  echo " </tr>\n";
  echo " <tr>\n";
  echo "  <td class='tbl1' nowrap>"."Date".":</td>\n";
  echo "  <td class='tbl1' nowrap><select name='photo_date_d' class='textbox'>$day_list</select>&nbsp;<select name='photo_date_m' class='textbox'>$month_list</select>&nbsp;<input type='text' class='textbox' name='photo_date_y' value='{$photo_date_y}' style='width:40px;'>&nbsp;<input type='text' class='textbox' name='photo_date_t' value='{$photo_date_t}' style='width:63px;'></td>\n";
  echo " </tr>\n";
  echo " <tr>\n";
  echo "  <td class='tbl1' nowrap colspan='2'><hr></td>\n";
  echo " </tr>\n";
  if($photo_has_image && $action=='edit'){
    $photo_info=sprintf('%dx%d pixels (%s)',$photo_info_matches[2],$photo_info_matches[3],$image_types_map[$photo_info_matches[1]]);
    echo " <tr>\n";
    echo "  <td class='tbl1' nowrap colspan='2'>"."Current Image".":&nbsp;&nbsp;[<a class='small' href='{$PHP_SELF}?action=delete&t=photoimage&photo_id={$photo_id}'>"."Remove"."</a>]</td>\n";
    echo " </tr>\n";
    echo " <tr>\n";
    echo "  <td class='tbl1' nowrap colspan='2' align='center'><a class='gallery-album' target='_blank' href='".FUSION_BASE."getpgimage.php?t=photo&id={$photo_id}' title='"."Click to view this image"."'><img src='".FUSION_BASE."getpgimage.php?t=photo&id={$photo_id}&w={$settings['pg_thumb_max_w']}&h={$settings['pg_thumb_max_h']}' border='0'></a><br /><span class='small'>{$photo_info}</span></td>\n";
    echo " </tr>\n";
  }else{
    echo " <tr>\n";
    echo "  <td class='tbl1' nowrap valign='top'>"."Upload Image".":</td>\n";
    echo "  <td class='tbl1' nowrap><input type='file' name='photo_pic_file' class='textbox' size='33' style='width:250px;'></td>\n";
    echo " </tr>\n";
    echo " <tr>\n";
    echo "  <td class='tbl1' nowrap valign='top'>"."Get From URL".":</td>\n";
    echo "  <td class='tbl1' nowrap><input type='text' name='photo_pic_url' value='' class='textbox' style='width:250px;'></td>\n";
    echo " </tr>\n";
    echo " <tr>\n";
    echo "  <td class='tbl1' nowrap valign='top'>"."Allowed Types".":</td>\n";
    echo "  <td class='tbl1'><span class='small'>".implode(', ',pg_get_allowed_image_types())."</span></td>\n";
    echo " </tr>\n";
  }
  echo " <tr>\n";
  echo "  <td class='tbl1' nowrap colspan='2'><hr></td>\n";
  echo " </tr>\n";
  echo " <tr>\n";
  echo "  <td class='tbl1' nowrap colspan='2' align='center'><input type='submit' name='btn_save_photo' value='".'Save Photo'."' class='button'>".($action=='edit' || isset($error)?"&nbsp;<input type='submit' name='btn_cancel' value='".'Cancel'."' class='button'>":"")."</td>\n";
  echo " </tr>\n";
  echo "</table>\n";
  echo "</form>\n";
  closetable();
  tablebreak();
  if($action=='edit'){
    opentable("Photo Ratings");
    if($settings['pg_allowed_ratings']=='1'){
      $ratings=array(5=> RATING_120, 4=> RATING_121, 3=> RATING_122, 2=> RATING_123, 1=> RATING_124);
      $tot_votes = dbresult(dbquery("SELECT COUNT(rating_item_id) FROM {$fusion_prefix}ratings WHERE rating_item_id='{$photo_id}' AND rating_type='P'"),0);
      if($tot_votes){
        echo "<table align='center' cellpadding='0' cellspacing='1' class='tbl-border'>\n";
        echo " <tr>\n";
        echo "  <td>\n";
        echo "   <table align='center' cellpadding='0' cellspacing='0'>\n";
        foreach($ratings as $rating=>$rating_info) {
          $num_votes = dbresult(dbquery("SELECT COUNT(rating_item_id) FROM {$fusion_prefix}ratings WHERE rating_item_id='{$photo_id}' AND rating_type='P' AND rating_vote='{$rating}'"),0);
          $pct_rating = number_format(100 / $tot_votes * $num_votes);
          if ($num_votes == 0) {
            $votecount = "[".RATING_108."]";
          } elseif ($num_votes == 1) {
            $votecount = "[1 ".RATING_109."]";
          } else {
            $votecount = "[{$num_votes} ".RATING_110."]";
          }
          $class = ($rating % 2==0?"tbl1":"tbl2");
          echo "    <tr>\n";
          echo "     <td class='{$class}'>$rating_info</td>\n";
          echo "     <td class='{$class}' width='250'><img src='".FUSION_THEME."images/pollbar.gif' height='12' width='{$pct_rating}%' class='poll'></td>\n";
          echo "     <td class='{$class}'>{$pct_rating}%</td>\n";
          echo "     <td class='{$class}'>$votecount</td>\n";
          echo "    </tr>\n";
        }
        echo "   </td>\n   </table>\n  </td>\n </tr>\n</table>";
      }else{
        echo RATING_101."\n";
      }
    }else{
      echo "Photo Ratings are disabled"."\n";
    }
    closetable();
    tablebreak();
    opentable("Photo Comments");
    if($settings['pg_allowed_comments']=='1'){
      $result=dbquery(
        "SELECT tcm.*,user_name ".
        "FROM {$fusion_prefix}comments tcm ".
        "LEFT JOIN {$fusion_prefix}users tcu ON tcm.comment_name=tcu.user_id ".
        "WHERE comment_item_id='$photo_id' AND comment_type='P' ".
        "ORDER BY comment_datestamp ASC"
      );
      if (dbrows($result) != 0) {
        $i = 0;
        echo "<table width='100%' cellpadding='0' cellspacing='1' class='tbl-border'>\n";
        while ($data = dbarray($result)) {
          echo "<tr>\n<td class='".($i%2==0?"tbl1":"tbl2")."'><span class='comment-name'>\n";
          if ($data['user_name']) {
            echo "<a href='".FUSION_BASE."profile.php?lookup={$data['comment_name']}'>{$data['user_name']}</a>";
          } else {
            echo $data['comment_name'];
          }
          echo "</span>\n<span class='small'>".LAN_41.showdate('longdate',$data['comment_datestamp'])."</span><br>".parsesmileys(parseubb($data['comment_message']))."</td>\n</tr>\n";
          $i++;
        }
        echo "</table>\n";
      } else {
        echo COMMENT_101."\n";
      }
    }else{
      echo "Photo Comments are disabled"."\n";
    }
    closetable();
    tablebreak();
  }
  if($action==''){
    opentable("Current Photos");
    echo "<form name='frm_pg_change_album' method='post' action='{$PHP_SELF}'>\n";
    echo "<table border='0' cellpadding='0' cellspacing='0' width='100%'>\n";
    echo " <tr>\n";
    echo "  <td class='tbl1' align='right'><a href='".FUSION_ADMIN."photoalbums.php' title='".'Close Album'."'>".'Close Album'."</a> | "."Open Album".":&nbsp;<select name='album_id' class='textbox' onChange='javascript:document.frm_pg_change_album.submit();'>".pg_build_album_optionlist(false,0,$album_id)."</select></td>\n";
    echo " </tr>\n";
    echo "</table>\n";
    echo "</form>\n";
    echo "<form name='frm_pg_image_list' method='post' action='{$PHP_SELF}' onSubmit=\"return ValidateForm(this,'chk_mark[]')\">\n";
    echo "<input type='hidden' name='t' value='photo'>\n";
    echo "<input type='hidden' name='album_id' value='{$album_id}'>\n";
    echo "<table border='0' cellpadding='0' cellspacing='1' width='100%' class='tbl-border'>\n";
    echo " <tr>\n";
    echo "  <td class='forum-caption' width='*' colspan='3'>"."Title - (Click to edit photo)"."</td>\n";
    echo "  <td class='forum-caption' nowrap width='5%' align='center'>"."Date"."</td>\n";
    echo "  <td class='forum-caption' nowrap width='5%'>"."Added By"."</td>\n";
    echo "  <td class='forum-caption' nowrap width='5%' align='center'>"."Image"."</td>\n";
    echo "  <td class='forum-caption' nowrap width='5%' align='center'>"."Views"."</td>\n";
    echo "  <td class='forum-caption' nowrap width='5%' align='center'>"."Comments"."</td>\n";
    echo "  <td class='forum-caption' nowrap width='5%' colspan='2' align='center'>"."Order"."</td>\n";
    echo " </tr>\n";
    $cnt_photos=dbresult(dbquery("SELECT COUNT(photo_id) FROM {$fusion_prefix}photos WHERE album_id='{$album_id}'"),0);
    list($page,$page_cnt,$limit_start,$limit_count)=prepPageNav($page,$cnt_photos,$settings['pg_thumbs_per_page']);  // get pagination parameters
    $q_images=dbquery(
      "SELECT tp.photo_id,tp.photo_active,tp.photo_title, tp.photo_order, tp.photo_date, tp.user_id, tp.photo_views, tp.photo_info, user_name, COUNT(comment_id) comment_count ".
      "FROM ({$fusion_prefix}photos tp ".
      "LEFT JOIN {$fusion_prefix}users USING(user_id)) ".
      "LEFT JOIN {$fusion_prefix}comments ON photo_id = comment_item_id AND comment_type = 'P' ".
      "WHERE album_id='{$album_id}' ".
      "GROUP BY photo_id ".
      "ORDER BY photo_order ".
      "LIMIT {$limit_start},{$limit_count}"
    );

        $grps=substr($d_album_info['cat_data'],1,-1);  // remove surrounding '.' characters
        $cat_groups_1=explode('.',$grps);
        $cat_groups_2=array();
        foreach($cat_groups_1 as $key=>$cat_group) { $cat_groups_2[]=getgroupname($cat_group); }
        $str_cat_groups=implode(', ',array_values($cat_groups_2));

    echo " <tr>\n";
    echo "  <td class='tbl2' colspan='10'>\n";
    echo "   <table border='0' cellpadding='0' cellspacing='0' width='100%'>\n";
    echo "    <tr>\n";
    echo "     <td nowrap><b>".stripslashes($d_album_info['cat_title'])." - ".stripslashes($d_album_info['album_title'])."</b>

<br /><span class='small'>Accessible to: {$str_cat_groups}</span>

</td>\n";
    echo "     <td nowrap align='right'><span class='small'>";
    if($d_album_info['photo_count']!=0) echo "<a href='{$PHP_SELF}?action=repairorder&t=album&album_id={$d_album_info['album_id']}'>"."Repair Ordering"."</a>";
    echo "</span></td>\n";
    echo "    </tr>\n";
    echo "   </table>\n";
    echo "  </td>\n";
    echo " </tr>\n";
    if(dbrows($q_images)!=0){
      while($d_images=dbarray($q_images)){
        preg_match('/^([0-9]+)\|([0-9]+)\|([0-9]+)$/',$d_images['photo_info'],$photo_info_matches);
        if($cnt_photos!=1){
          if($d_images['photo_order']==1){
            $up_down="<a href='{$PHP_SELF}?action=moved&t=photo&album_id={$album_id}&photo_id={$d_images['photo_id']}'><img src='".FUSION_THEME."images/down.gif' border='0' /></a>";
          }elseif($d_images['photo_order']<$cnt_photos){
            $up_down="<a href='{$PHP_SELF}?action=moveu&t=photo&album_id={$album_id}&photo_id={$d_images['photo_id']}'><img src='".FUSION_THEME."images/up.gif' border='0' /></a>";
            $up_down.="&nbsp;<a href='{$PHP_SELF}?action=moved&t=photo&album_id={$album_id}&photo_id={$d_images['photo_id']}'><img src='".FUSION_THEME."images/down.gif' border='0' /></a>";
          }else{
            $up_down="<a href='{$PHP_SELF}?action=moveu&t=photo&album_id={$album_id}&photo_id={$d_images['photo_id']}'><img src='".FUSION_THEME."images/up.gif' border='0' /></a>";
          }
        }else{
          $up_down = "-";
        }
        echo " <tr>\n";
        echo "  <td class='tbl1' style='padding:0px;' nowrap width='3%' align='center'><input type='checkbox' name='chk_mark[]' value='{$d_images['photo_id']}'></td>\n";
        echo "  <td class='tbl1' nowrap width='2%' align='center'><img src='".FUSION_IMAGES.$album_state_map[$d_images['photo_active']][0]."' border='0' title='".$album_state_map[$d_images['photo_active']][1]."'></td>\n";
        echo "  <td class='tbl1' nowrap><a href='{$PHP_SELF}?action=edit&t=photo&album_id={$album_id}&photo_id={$d_images['photo_id']}'>".stripslashes($d_images['photo_title'])."</a></td>\n";
        echo "  <td class='tbl1' nowrap align='center'>".showdate('forumdate',$d_images['photo_date'])."</td>\n";
        echo "  <td class='tbl1' nowrap><a href='".FUSION_BASE."profile.php?lookup={$d_images['user_id']}'>{$d_images['user_name']}</a></td>\n";
        echo "  <td class='tbl1' nowrap align='center'>".(count($photo_info_matches)==4?$image_types_map[$photo_info_matches[1]]:'-')."</td>\n";
        echo "  <td class='tbl1' nowrap align='center'>".($d_images['photo_views']==0?"None":$d_images['photo_views'])."</td>\n";
        echo "  <td class='tbl1' nowrap align='center'>".($d_images['comment_count']==0?"None":$d_images['comment_count'])."</td>\n";
        echo "  <td class='tbl1' nowrap width='2%' align='center'><span class='small'>{$d_images['photo_order']}</span></td>\n";
        echo "  <td class='tbl1' nowrap width='3%' align='center'>{$up_down}</span></td>\n";
        echo " </tr>\n";
      }
    }else{
      echo " <tr>\n";
      echo "  <td class='tbl1' nowrap width='3%' align='center'><img src='".FUSION_IMAGES."cross_red.gif' border='0' alt='"."Loading Image..."."' title='title'>\n";
      echo "  <td class='tbl1' nowrap width='97%' colspan='8'>"."No Photos defined."."</td>\n";
      echo " </tr>\n";
    }
    echo "</table>\n";
    if(dbrows($q_images)!=0) {
      echo "<table border='0' cellpadding='0' cellspacing='0' width='100%'>\n";
      echo " <tr>\n";
      echo "  <td><span class='small'><input type='button' class='button' title='"."Click to mark all images"."' onclick=\"javascript:setChecked('frm_pg_image_list','chk_mark[]',1);\" value='"."Mark All"."'</input>&nbsp;<input type='button' class='button' title='"."Click to unmark all images"."' onclick=\"javascript:setChecked('frm_pg_image_list','chk_mark[]',0);\" value='"."Unmark All"."'</input></span></td>\n";
      echo "  <td align='right'>"."With marked images:"."&nbsp;";
      echo "<input type='submit' class='button' name='btn_activate' title='"."Activate"."' value='"."Activate"."'>&nbsp;";
      echo "<input type='submit' class='button' name='btn_deactivate' title='"."Deactivate"."' value='"."Deactivate"."'>&nbsp;";
      echo "<input type='submit' class='button' name='btn_delete' title='"."Delete"."' value='"."Delete"."'>&nbsp;|&nbsp;";
      echo "Move to <select name='photo_move_album' class='textbox' style='width:auto;'>".pg_build_album_optionlist(false,0,$album_id)."</select>&nbsp;";
      echo "<input type='submit' class='button' name='btn_move' title='"."Go"."' value='"."Move"."'></td>\n";
      echo " </tr>\n";
      echo "</table>\n";
    }
    if($cnt_photos>$settings['pg_thumbs_per_page']){
      tablebreak();
      echo "<table border='0' cellpadding='0' cellspacing='0' width='100%' class=''>\n";
      echo " <tr>\n";
      echo "  <td align='center'>".makePageNavAll($page,$page_cnt,null,"{$PHP_SELF}?album_id={$album_id}&")."</td>\n";
      echo " </tr>\n";
      echo "</table>\n";
    }
//     tablebreak();
//     echo "<table border='0' align='center' cellpadding='0' cellspacing='1' class='tbl-border'>\n";
//     echo " <tr>\n";
//     echo "  <td class='tbl2'><span class='small'><a href='".FUSION_ADMIN."photoalbums.php' title='".'Close Album'."'>".'Close Album'."</a></span></td>\n";
//     echo " </tr>\n";
//     echo "</table>\n";
    echo "</form>\n";
    echo "<script language='Javascript'>
function confirmDelete(name){return confirm('"."Delete "."\''+name+'\'\\n\\nAre you sure ?');}
function ValidateForm(frm){if((frm.subject.value=='')||(frm.message.value=='')){alert('"."Please select at least one record to be actioned"."');return false;}else return true;}
function setChecked(frmName,chkName,val){
  dml=document.forms[frmName];
  len=dml.elements.length;
  for(i=0;i<len;i++){
    if(dml.elements[i].name==chkName){
      dml.elements[i].checked=val;
    }
  }
}
function ValidateForm(dml,chkName){
  len=dml.elements.length;
  for(i=0;i<len;i++){
    if((dml.elements[i].name==chkName)&&(dml.elements[i].checked==1)) return true
  }
  alert('Please select at least one record to be actioned')
  return false;
}
</script>";
//     tablebreak();
//     $storage_type = ($settings['pg_image_storage']=='f'?'file':'database');
//     echo "Image Storage Mode: {$storage_type}";
    closetable();

tablebreak();
pg_show_db_info();

  }
}

echo "</td>\n";
include FUSION_BASE."footer.php";
?>