<?php
/*--------------------------------------------+
| PHP-Fusion 5 - Content Management System    |
|---------------------------------------------|
| Photo Gallery v3 - Alpha Release 1          |
|---------------------------------------------|
| Released under the terms and conditions of  |
| the GNU General Public License (Version 2)  |
+---------------------------------------------+
| Photo Gallery coded by CrappoMan            |
|                    (a.k.a. Simon Patterson) |
| email: crappoman@email.com                  |
+--------------------------------------------*/

//
// getpgimage.php
// Send a photogallery image to the browser.
// Syntax: <img src="getthumb.php?t=album&id=xx">
// Syntax: <img src="getthumb.php?t=thumb&id=xx">

// Allowed URL params:
//  t = album|photo  display ALBUM or PHOTO image
//  id= 123          image ID
//  w = 123          maximum width of output image (optional)
//  h = 123          maximum height of output image (optional)
//  u = gif|jpg|png  type of output image   (optional)
//  q = 1-100        quality of jpeg output (optional)
//  sized            turns off aspect ratio protection

@require_once "fusion_config.php";
require_once "fusion_core.php";
require_once FUSION_INCLUDES."pg_core.php";

$contenttype_map=array(
 'gif'  => 'image/gif',
 'jpg'  => 'image/jpeg',
 'png'  => 'image/png',
);

$db_names=array(
 'album' => array('album_info','album_data','photo_albums','album_id'),
 'photo' => array('photo_info','photo_data','photos','photo_id')
);

$imageerror=0;
if(!preg_match('/^album|photo+$/',$t) || !isNum($id)) $imageerror++;

if(isset($_GET['w'])) $w=stripinput($_GET['w']); else $w=0;
if(isset($_GET['h'])) $h=stripinput($_GET['h']); else $h=0;
if(isset($_GET['u']) && in_array($_GET['u'],array_keys($contenttype_map))) $u=stripinput($_GET['u']); else $u=$settings['pg_default_img_type'];
if(isset($_GET['q']) && preg_match('/^1?[0-9]{1,2}$/',$_GET['q'])) $jpg_q=stripinput($_GET['q']); else $jpg_q=$settings['pg_default_jpeg_quality'];
if(isset($_GET['sized'])) $sized=1; else $sized=0;



$result=dbquery("SELECT {$db_names[$t][0]} AS img_info,{$db_names[$t][1]} AS img_data FROM {$fusion_prefix}{$db_names[$t][2]} WHERE {$db_names[$t][3]}='{$id}'");
if(dbrows($result)!=0){
  $data=dbarray($result);
  preg_match('/^([0-9]+)\|([0-9]+)\|([0-9]+)$/',$data['img_info'],$image_info_matches);
  if(count($image_info_matches)==4){
    $img_w=$image_info_matches[2];
    $img_h=$image_info_matches[3];
    if($settings['pg_image_storage']=='d'){
      $img_res=imagecreatefromstring(base64_decode($data['img_data']));
    }elseif($settings['pg_image_storage']=='f'){
      $file=FUSION_PHOTOS.($t=='album'?'a':'')."{$id}.{$image_types_map[$image_info_matches[1]]}";
      if(file_exists($file)){
        $img_res=imagecreatefromstring(file_get_contents($file));
      }else{
        $imageerror++;
      }
    }
  }else{
    $imageerror++;
  }
}else{
  $imageerror++;
}

//if($img_res==false) exit();

if($imageerror){
  $u='png';
  $img_res=imagecreatefrompng(FUSION_IMAGES.'noimage.png');
}


$img_w=imagesx($img_res);  // calculate thumb size
$img_h=imagesy($img_res);
list($out_w,$out_h)=constrainImage($img_w,$img_h,$w,$h,$sized);
$img_thumb=pg_image_create_function($out_w,$out_h);
@imageantialias($img_thumb,true);  // turn on alti-aliasing. function may not exist so prefix with @
pg_image_resize_function($img_thumb,$img_res,0,0,0,0,$out_w,$out_h,$img_w,$img_h);

switch($settings['pg_wmark_type']){
 case 'image':
  if($img_watermark=@imagecreatefromstring(@file_get_contents($settings['pg_wmark_image_file']))){
    $wmark_type=getimagesize($settings['pg_wmark_image_file']);
    ImageOverlayFunction($img_thumb,$img_watermark,$wmark_type[2],$settings['pg_wmark_align'],$settings['pg_wmark_opacity'],$settings['pg_wmark_margin']);
    imagedestroy($img_watermark);
  }
  break;
 case 'text':
//  if(!$settings['pg_wmark_text']) return false;
  $font=realpath($settings['pg_ttf_font_dir'].$settings['pg_wmark_font']);
  $is_ttf=(is_readable($font) && is_file($font));
  $text_size=$settings['pg_wmark_size'];
  if($is_ttf){
    $TTFbox=imagettfbbox($text_size,$settings['pg_wmark_angle'],$font,$settings['pg_wmark_text']);
    $text_x=$settings['pg_wmark_margin']+max($TTFbox[2],$TTFbox[4])-min($TTFbox[0],$TTFbox[6]); // extreme x values
    $text_y=$settings['pg_wmark_margin']+max($TTFbox[1],$TTFbox[3])-min($TTFbox[5],$TTFbox[7]); // extreme y values
  }else{
    $text_size=min(5,max(1,$text_size));
    $text_x=imagefontwidth($text_size)*strlen($settings['pg_wmark_text']);
    $text_y=imagefontheight($text_size);
  }
  if($img_watermark=ImageCreateFunction($text_x,$text_y)){
    $text_color_transparent=imagecolorallocatealpha($img_watermark,255,0,255,127);
    imagealphablending($img_watermark,false);
    imagefilledrectangle($img_watermark,0,0,imagesx($img_watermark),imagesy($img_watermark),$text_color_transparent);
    $text_color_watermark=imagecolorallocatealpha($img_watermark,hexdec(substr($settings['pg_wmark_hex_color'],0,2)),hexdec(substr($settings['pg_wmark_hex_color'],2,2)),hexdec(substr($settings['pg_wmark_hex_color'],4,2)),127-(127*($settings['pg_wmark_opacity']/100)));
    if($is_ttf){
      $offsety=$text_y-$settings['pg_wmark_margin'];
      $offsetx=$settings['pg_wmark_margin']/2+($settings['pg_wmark_margin']*$settings['pg_wmark_angle'])/60;
      imagettftext($img_watermark,$text_size,$settings['pg_wmark_angle'],$offsetx,$offsety,$text_color_watermark,$font,$settings['pg_wmark_text']);
    }else{
      imagestring($img_watermark,$text_size,0,0,$settings['pg_wmark_text'],$text_color_watermark);
    }
    ImageOverlayFunction($img_thumb,$img_watermark,($is_ttf?3:2),$settings['pg_wmark_align'],$settings['pg_wmark_opacity'],$settings['pg_wmark_margin']);
    imagedestroy($img_watermark);
  }
  break;
}
header('Content-type: '.$contenttype_map[$u]);  // output image of appropriate type to browser
switch($u){
 case 'gif':
  imagegif($img_thumb);
  break;
 case 'png':
  imagealphablending($img_thumb,false);
  imagesavealpha($img_thumb,true);
  imagepng($img_thumb);
  break;
 case 'jpg':
 default:
  imagejpeg($img_thumb,'',$jpg_q);
  break;
}
imagedestroy($img_thumb);  // destroy image resources
imagedestroy($img_res);
?>